program dvi1;

uses crt;

type  sar = ^Elemtipas;
       Elemtipas = record
        sk: integer;
        kitas, pries: sar;
        end;

var n: integer;                                                          // Skaicius,kuri nuskaito is failo
    sar_head, sar_tail: sar;
    Duomenufailas:string;
    Duom:text;
    ma,mi,sarilg:integer;                                                // Maksimali ir minimali saraso reiksmes ir saraso ilgis
    skai:integer;                                                        // Norimas iterpti skaicius
    Atsakymas:string;
    pozicija:integer;

// Skaiciaus iterpimas i saraso vidu tarp mazenio ir didesnio uz ivesta skaiciu.
procedure iterpti(var pr:sar; X:integer);
var elem,elemn:sar;
begin
    elem:=pr;
    while elem <> nil do
    begin
        if (elem^.sk >= X)  then
        begin
            new(elemn);
            elemn^.sk:=X;
            elemn^.pries:=elem^.pries;                        // mazesnis --> naujas
            elem^.pries^.kitas:=elemn;                        // mazesnis <-- naujas
            elemn^.kitas:=elem;                               // naujas --> didesnis
            elem^.pries:=elemn;                               // naujas <-- didesnis
            break;                                            // Baigia darba, nes patenkinta salyga
        end
                            else
            elem:=elem^.kitas;                                // perejimas prie kito elemento
    end;
end;
// Proceduros Iterpti pabaiga




procedure Rusiuoti(var pr : Sar; var ilg:integer);
var i, j, t,ilgis : integer;
    elem : Sar;
    skaicius : integer;
begin
ilgis := 0;
elem := pr;
while elem <> nil do
    begin
        ilgis:=ilgis+1;
        elem:=elem^.kitas;
    end;
    ilg:=ilgis;

if ilgis < 1 then Writeln('Saraso nera, todel nera ka rusiuoti.')
               else
    begin
    for t := 1 to ilgis-1 do
      for i := 1 to ilgis-1 do
      begin
        elem := pr;
        for j := 1 to ilgis-i do
        begin
            if elem^.sk > elem^.kitas^.sk then         // Lyginamas pvz 1 su 2 saraso skaiciumi
            begin
              skaicius := elem^.sk;
              elem^.sk := elem^.kitas^.sk;
              elem^.kitas^.sk := skaicius;
            end;
          elem := elem^.kitas;                         // Jei salyga nepatenkinta, sokama prie kito saraso nario
        end;
      end;
    end;
end;

procedure add(var galva, uodega: sar; int: integer);
var z: sar;
begin
  new(z);
  z^.sk:=int;
  if galva=nil then
  begin
    galva:=z;                                   // Atsiranda naujas elementas
    uodega:=z;                                  // Pabaigos ir pradzios rodykles nukreiptos i ji
    galva^.pries:=nil;                          // naujo elemento rodykle kuri rodo i pirma
    uodega^.kitas:=nil;                         // pirmo rodykles, kuri rodo i nauja
  end
  else
  begin
    uodega^.kitas:=z;                           // sukurtas <--- naujas
    z^.pries:=uodega;                           // sukurtas ---> naujas
    uodega:=z;                                  // <--- busima rodykle
    uodega^.kitas:=nil;                         // naujai sukurto rodykle ---> nill
  end;
end;


// Procedura spausdinanti sarasa
procedure print(galva: sar);
var h: sar;
begin
  h:= galva;
  while h<>nil do begin
    write(h^.sk,' ');
    h:=h^.kitas;
  end;
  writeln;
end;
// Proceduros pabaiga


procedure Naikinti ( var pr : sar );
begin // Naikinti_sar
writeln ('Naikiname sarasa nuo pabaigos.');
  while pr <> nil do
   begin
    dispose(pr^.pries); // Pasaliname elementa
    pr := pr^.pries;
   end;
pr := nil;
end; // Naikinti
begin
writeln('Iveskite duomenu failo pavadinima, kuris yra tame paciame aplanke kaip ir programa:');
    readln(Duomenufailas);

assign(duom,duomenufailas); {$i-}reset(duom);{$i+}
    if ioresult <> 0 then begin writeln('Duomenu failo pavadinimas neteisingas arba failas neegzistuoja aplanke.'); Halt; end;

CLRSCR;

  sar_head:=nil;                                  // Pradedamas kurti tuscias sarasas
  sar_tail:=nil;                                  // pradzios ir pabaigos rodyklems priskiriamas nil

  while not eof(duom) do
    begin
    read(Duom, n);
       add(sar_head, sar_tail,n);
    end;

writeln('Ivesti duomenys:');
  print(sar_head);
  rusiuoti(sar_head,sarilg);
writeln('Surusiuoti duomenys:');
  print(sar_head);
writeln;

  ma:=sar_tail^.sk;
  mi:=sar_head^.sk;

writeln('Iveskite skaiciu, kuri norite iterpti i sarasa.');

  readln(skai);

writeln('Ar norite iterpti savo skaiciu pats/pati? ');
writeln('Automatinis iterpimas galimas, jei skaicius mazesnis uz ',ma,', arba didesnis uz ',mi);
writeln('Iveskite "taip", jei norite pats/pati iterpti, ');
writeln('arba "ne", jei norite, kad uz jus iterptu.');
  readln(atsakymas);
CLRSCR;

print(sar_head);
writeln;
if (Atsakymas = 'taip') Then
    begin
    iterptipo(sar_head, skai ,sarilg ,pozicija);
    writeln('Sarasas su nauju elementu:');
    print(sar_head);
    end
                        else

if (Atsakymas = 'ne') then
  begin

  if (skai = mi) then begin itpradzia(sar_head, skai); writeln('Sarasas su nauju elementu:');print(sar_head);end;

  if (skai = ma) then begin itpabaiga(sar_head, skai); writeln('Sarasas su nauju elementu:');print(sar_head);end;

  if (skai>mi) and (skai<ma) then begin iterpti(sar_head, skai); writeln('Sarasas su nauju elementu:');print(sar_head);end;

  if (skai > ma) OR (skai < mi) then writeln('Jusu skaicius neatitiko automatinio iterpimo skaiciaus reziu: <',mi,' arba >',ma);
  end;
if Atsakymas = 'taip' then
writeln('Iterptas skaicius buvo: ', skai,' uz saraso nario ',pozicija);
writeln;
Naikinti(sar_tail);
end.
